
/*
-----------------------------------------------------------

  Navigation

  Uses Vue router if available. Falls back to window.location.

-----------------------------------------------------------
*/

const X = console.log

const formatPath = (path) => {

  X(path)

  let pathFormatted = ''

  if(!path){
    pathFormatted = path
  }
  else if(path.indexOf('/') == 0){
    pathFormatted = path
  }
  else{
    pathFormatted = `/${path}`
  }

  // X(pathFormatted)

  return pathFormatted

}

export default {

  to(path, router = null){

    const pathFormatted = formatPath(path)

    // X('HORSE')
    // if(typeof this.router != 'undefined' && this.router)
    //   X(router)
    // if(typeof this.$router != 'undefined' && this.$router)
    //   X(this.$router)
    // if(typeof this.$nuxt != 'undefined' && this.$nuxt)
    //   X(this.$nuxt)
    // X('END HORSE')

    // return
    
    X('navigateTo: checking router')

    // Vue Router
    if(typeof router != 'undefined' && router && router.push){
      X('router: router')
      router.push(pathFormatted)
    }
    // Nuxt
    else if(typeof navigateTo != 'undefined' && navigateTo){
      X('router: nuxt')
      navigateTo(pathFormatted)
    }
    // Regular Browser API
    else if(window){
      X('router: nope')
      window.location = pathFormatted
    }

  },

  hrefOnlyIfNeeded(path, router = null){

    const pathFormatted = formatPath(path)

    // X('HORSE')
    // if(typeof this.router != 'undefined' && this.router)
    //   X(router)
    // if(typeof this.$router != 'undefined' && this.$router)
    //   X(this.$router)
    // if(typeof this.$nuxt != 'undefined' && this.$nuxt)
    //   X(this.$nuxt)
    // X('END HORSE')

    let hrefIfNeeded = null

    // return

    // Vue Router
    if(typeof router != 'undefined' && router && router.push){
      // X('hrefOnlyIfNeeded: router: router')
      hrefIfNeeded = null
    }
    // Nuxt
    else if(typeof navigateTo != 'undefined' && navigateTo){
      // X('hrefOnlyIfNeeded: router: nuxt')
      hrefIfNeeded = null
    }
    // Regular Browser API
    else if(window){
      // X('router: nope')
      hrefIfNeeded = pathFormatted
    }

    return hrefIfNeeded

  },

  formatPath(path){
    
    // Return empty string if path is null or undefined
    if(!path){
      return ''
    }
    
    // Add slash to the beginning
    if(path[0] != '/'){
      path = '/' + path
    }
    
    // Remove slash from the end
    if(path[path.length - 1] == '/'){
      path = path.slice(0, -1)
    }
    
    // Remove any double slashes
    path = path.replace(/\/\//g, '/')

    return path
  },

}
