
/*
-----------------------------------------------------------

  Navigation

  Uses Vue router if available. Falls back to window.location.

-----------------------------------------------------------
*/

const X = console.log


export default {

  createAudioContainer(){

    console.log('createAudioContainer')

    let audioElement = null
      
    if(typeof process != 'undefined' && process && process.server){
      X('SERVER #creek-audio-container')
    }else{
      X('NOT SERVER #creek-audio-container')
    }


    if(

      // If this is in the browser, then create the <audio> element.
      typeof document != 'undefined' && document && !audioElement 
      
      // If this is Nuxt, then don't create the <audio> element 
      // on the server side.
      && (
        typeof process == 'undefined' 
        || !process 
        || (typeof process != 'undefined' && process && !process.server)
      )

    ){



      X('creating #creek-audio-container')

      audioElement = document.createElement('audio')

      audioElement.id       = 'creek-audio-container'
      audioElement.controls = 'controls'
      audioElement.style.display = 'none'
      audioElement.innerText = ''
      audioElement.innerHTML = ''

      // audioElement.type     = 'audio/mpeg'

      document.addEventListener("DOMContentLoaded", function(){
          document.body.prepend(audioElement)
      });


    }

    return audioElement


  }

}
