import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

const baseDir = '/Users/travis/Creek/projects/ws'

console.log('baseDir', baseDir + '/studio-website-toolkit')

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    vue(),
  ],
  resolve: {
    alias: {
      // '@': fileURLToPath(new URL('./src', import.meta.url)),
      '~creek-website-toolkit': baseDir + '/studio-website-toolkit'
    }
  }
})
